﻿using P5T.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using System.Web.Security;

namespace P5T
{
    public class AuthFilter : ActionFilterAttribute
    {
        public override void OnActionExecuting(ActionExecutingContext filterContext)
        {
            if(filterContext.RequestContext.HttpContext.Request.IsAuthenticated)
            {
                var researcher = ResearcherModel.Find(HttpContext.Current.User.Identity.Name);
                if (researcher != null)
                {
                    // Special case - run for all valid users.
                    filterContext.RouteData.DataTokens.Add("user", researcher);
                    return;        
                }
            }

            // Default case - run on all users who are not logged in.
            FormsAuthentication.SignOut();
            filterContext.Result = new RedirectToRouteResult(new RouteValueDictionary(new { controller = "Auth", action = "Login" }));
        }
    }
}