﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using P5T.Models;

namespace P5T.Controllers
{
    [AuthFilter]
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult Search(string query)
        {
            SearchModel search = new SearchModel();
            ViewBag.Query = query;

            if (!String.IsNullOrWhiteSpace(ViewBag.Query))
                search.SearchQuery(query);

            return View(search);
        }

        [HttpGet]
        public ActionResult DownloadFile(int id)
        {
            var attachment = AttachmentModel.Find(id);
            if (attachment != null)
            {
                return File(attachment.Data.Value, System.Net.Mime.MediaTypeNames.Application.Octet, attachment.Name);
            }
            return RedirectToAction("List", "Programs");
        }
    }
}
