﻿using P5T.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace P5T.Controllers
{
    [AuthFilter]
    public class NotificationsController : Controller
    {
        public ActionResult List()
        {
            var currentUser = this.RouteData.DataTokens["user"] as ResearcherModel;
            return View("~/Views/Notifications/List.cshtml", currentUser);
        }

        [HttpPost]
        public ActionResult dismissALL()
        {
            var currentUser = this.RouteData.DataTokens["user"] as ResearcherModel;
            NotificationModel.DeleteAllForUser(currentUser.Id);
            return Json(new { success = true });
        }

        [HttpPost]
        public ActionResult dismissPR(int id)
        {
            ProgramNotificationModel.Delete(id);
            return Json(new { success = true });
        }

        [HttpPost]
        public ActionResult dismissRA(int id)
        {
            ResearchArticleNotificationModel.Delete(id);
            return Json(new { success = true });
        }

        [HttpPost]
        public ActionResult dismissJA(int id)
        {
            JournalArticleNotificationModel.Delete(id);
            return Json(new { success = true });
        }

        [HttpPost]
        public ActionResult dismissMI(int id)
        {
            MediaInterviewNotificationModel.Delete(id);
            return Json(new { success = true });
        }

        [HttpPost]
        public ActionResult dismissCP(int id)
        {
            ConferencePresentationNotificationModel.Delete(id);
            return Json(new { success = true });
        }

        [HttpPost]
        public ActionResult dismissGR(int id)
        {
            GrantNotificationModel.Delete(id);
            return Json(new { success = true });
        }

        [HttpPost]
        public ActionResult dismissOT(int id)
        {
            OtherNotificationModel.Delete(id);
            return Json(new { success = true });
        }
    }
}
