﻿using P5T.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.Mvc;

namespace P5T.Controllers
{
    [AuthFilter]
    public class ResearchersController : Controller
    {
        [HttpPost]
        public ActionResult ListAuthors()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("{\"result\": [");

            string sep = "";
            foreach(var author in AuthorModel.List())
            {

                sb.Append(sep);
                sb.Append("\"");

                sb.Append(author.FirstName);
                sb.Append(" ");

                if (author.MiddleInitial.HasValue)
                {
                    sb.Append(author.MiddleInitial.Value);
                    sb.Append(". ");
                }

                sb.Append(author.LastName);

                sb.Append("\"");

                sep = ",";
            }

            sb.Append("]}");
            return Json(sb.ToString());
        }

        [HttpGet]
        public ActionResult List()
        {
            return View(ResearcherModel.FindAll());
        }

        [HttpGet]
        public ActionResult View(int id)
        {
            var researcher = ResearcherModel.Find(id);
            if (researcher == null)
            {
                return RedirectToAction("List");
            }

            ViewBag.SecondaryAffiliations = researcher.Author.Value.SecondaryAffiliations;

            HashSet<int> prelimSet = new HashSet<int>();

            foreach (var artifact in ResearchArticleModel.FindByAuthor(id))
            {
                prelimSet.Add((int)artifact.Program.RawValue);
            }

            foreach (var artifact in JournalArticleModel.FindByAuthor(id))
            {
                prelimSet.Add((int)artifact.Program.RawValue);
            }

            foreach (var artifact in ConferencePresentationModel.FindByAuthor(id))
            {
                prelimSet.Add((int)artifact.Program.RawValue);
            }

            foreach (var artifact in MediaInterviewModel.FindByAuthor(id))
            {
                prelimSet.Add((int)artifact.Program.RawValue);
            }

            foreach (var artifact in GrantModel.FindByAuthor(id))
            {
                prelimSet.Add((int)artifact.Program.RawValue);
            }

            foreach (var artifact in OtherModel.FindByAuthor(id))
            {
                prelimSet.Add((int)artifact.Program.RawValue);
            }

            List<ProgramModel> programs = new List<ProgramModel>();
            foreach(var program_id in prelimSet)
            {
                var model = ProgramModel.Find(program_id);
                if (!model.ArchivalDate.HasValue)
                {
                    programs.Add(ProgramModel.Find(program_id));
                }
            }

            ViewBag.Programs = programs;

            return View(researcher);
        }
    }
}
