﻿
$(document).ready(function () {

    // Adds an effect to clear the modalCallback function on hiding of a modal.
    $('#modal').on('hide.bs.modal', function () { modalCallback = function () { } });

    // Performs a highlight of the selected element on the page.
    if (window.location.hash) {
        $(window.location.hash).effect('highlight', { color: '#FFFF00' }, 3000);
    }

    // Javascript to enable link to tab
    var url = document.location.toString();
    if (url.match('#')) {
        $('.nav-tabs a[href=#' + url.split('#')[1].split('_')[0] + ']').tab('show');
    }

    // Change hash for page-reload
    $('.nav-tabs a').on('shown', function (e) {
        window.location.hash = e.target.hash;
    })

});

function displayError(msg) {
    $('#validation_error').html(msg);
    $('#validation_alert').show();
    return false;
};

function lengthCheck(str, name, min, max) {
    if (min > 0 && str.length == 0) {
        return displayError(name + ' is required.');
    } else if (str.length < min) {
        return displayError(name + ' requires at least ' + min + ' characters.');
    } else if (str.length > max) {
        return displayError(name + ' cannot be longer than ' + max + ' characters.');
    }
    return true;
}

function dateCheck(str, name) {
    if (str.length == 0) {
        return displayError(name + ' is required.');
    }
   return true;
}

function usernameAvailabilityCheck(username) {
    return true;
}

function passwordCheck(p1, p2) {
    if (p1 != p2)
        return displayError('Passwords do not match.');
    else if (p1.length < 8)
        return displayError('Passwords must be at least 8 characters long.');

    // TODO: More password requirements here.

    return true;
}

function phoneNumberCheck(pn) {
    var re = /^[0-9]{10}$/;
    if (!re.test(pn)) {
        return displayError('Phone numbers must be of the form XXXXXXXXXX.')
    }

    return true;
}

function emailCheck(email) {
    var re = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;
    if (!re.test(email)) {
        return displayError('Email address is invalid.');
    }
    return true;
}